<?php
/**
* @version $Id: geocder.userplugin.php,v 1.2 2005/07/13 07:48:17 mambojoe Exp $
* @package Community Builder
* @subpackage Geocoder
* @copyright (C) ATLspecails.com
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

global $mosConfig_absolute_path;
require_once($mosConfig_absolute_path.'/administrator/components/com_google_maps/google_maps.class.php');

function plug_geocoder_install() {
	return "Geocoder Plugin Successfully Installed";
}
function plug_geocoder_uninstall() {
	return "Geocoder Plugin Succesfully Removed";
}

// For some reason this does not work yet.
$_PLUGINS->registerFunction( 'onBeforeUserUpdate' , 'geocodeAddress', 'getGeocoderTab'  );
$_PLUGINS->registerFunction( 'onBeforeUserRegistration' , 'geocodeAddress', 'getGeocoderTab'  );
$_PLUGINS->registerFunction( 'onBeforeNewUser' , 'geocodeAddress', 'getGeocoderTab'  );





/**
* Forum Tab Class for handling the CB tab api
* @package Community Builder
* @author JoomlaJoe and Beat
*/
class getGeocoderTab extends cbTabHandler {
	/**
	* Constructor
	*/
	function getGeocoderTab() {
		$this->cbTabHandler();
	}
  
    function geocodeAddress($user,$cbUser) {	
    
        $params = $this->params;
	

        /* 
        * convert the user parameters passed to the event to a format the 
        * external appliction understands
        */
    
    
        $args = array();
        $args['address'] = $params->get('geoAddress','');
        $args['city'] 	  = $params->get('geoCity','');
        $args['state'] = $params->get('geoState','');
        $args['country'] = $params->get('geoCountry','');
        $args['zipcode'] = $params->get('geoPostcode','');
        $args['customone'] = $params->get('geoCustomone','');
        $args['customtwo'] = $params->get('geoCustomtwo','');
        $args['customthree'] = $params->get('geoCustomthree','');
        $args['customfour'] = $params->get('geoCustomfour','');
        $args['customfive'] = $params->get('geoCustomfive','');
     
        $args["lat"] = 'cb_geolatitude';
        $args["lng"] = 'cb_geolongitude';

        $loc = new geocoder($cbUser,$args['address'],$args['city'],$args['state'],$args['country'],$args['zipcode'],$args['lat'],$args['lng']);
        $loc->geocodeAddress();
        $cbUser->$args["lat"] = ($loc->latitude) ? $loc->latitude : $cbUser->$args["lat"];
        $cbUser->$args["lng"] = ($loc->longitude) ? $loc->longitude : $cbUser->$args["lng"];
 
    }
	
    /**
	* Generates the HTML to display the user profile tab
	* @param object tab reflecting the tab database entry
	* @param object mosUser reflecting the user being displayed
	* @param int 1 for front-end, 2 for back-end
	* @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
	*/
	function getDisplayTab($tab,$user,$ui) {
		$params = $this->params;
//		$lng		= $params->get('geoLng', 'Text Parameter not set!');
//		$lat		= $params->get('geoLat', 'Text Parameter not set!');
        
        $ret = "";
//		$ret .= "<p>Latitude: ".$user->$lat."</p>";
//		$ret .= "<p>Longitude: ".$user->$lng."</p>";
		return $ret;
	}
	
	/**
	* Generates the HTML to display the user edit tab
	* @param object tab reflecting the tab database entry
	* @param object mosUser reflecting the user being displayed
	* @param int 1 for front-end, 2 for back-end
	* @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
	*/
	function getEditTab($tab,$user,$ui) {
		$params = $this->params;
/*		
		$jsvalidation  =  "var t = new RegExp(\"/?:[ ]?[-+]?\d+(?:\.\d+)?[ ]?/\", \"i\");\n";
		$jsvalidation .=  "\n";
		$jsvalidation .=  "\n";
		$jsvalidation .=  "\nif(!t.exec(me['cb_geolatitude'].value)) {\n";
		$jsvalidation .=  " errorMSG += 'You must enter a number for the latitude.';\n";
		$jsvalidation .=  " iserror = 1;\n";
		$jsvalidation .=  "}\n";
		$this->_addValidationJS($jsvalidation);
*/
//		$lng		= $params->get('geoLng', 'Text Parameter not set!');
//		$lat		= $params->get('geoLat', 'Text Parameter not set!');

        $ret = "";
//		$ret .= "<p>Latitude: ".$user->$lat."</p>\n";
//		$ret .= "<p>Longitude: ".$user->$lng."</p>\n";
		
		return $ret;
	}
	
}	// end class getExampleTab.
?>